stages:
  - build
  - deploy
  - test

variables:
  SERVER_NAME: saico-server-test.duckdns.org
  SRC_REPO: "https://github.com/fravega/pyecho/"
  IMAGE: pyecho

before_script:
  - mkdir -p ~/.ssh
  - echo -e "Host *\n\tStrictHostKeyChecking no\n\tIdentityFile ~/.ssh/id_rsa\n\n" > ~/.ssh/config
  - echo "$SSH_KEY" > ~/.ssh/id_rsa
  - chmod -R 700 ~/.ssh

build_image:
  stage: build
  image: docker:stable
  only:
    - tags
  services:
    - docker:dind
  script:
    - apk update
    - apk upgrade
    - apk add python3 python3-dev py-pip build-base libffi-dev libressl-dev libgcc docker-compose git
    - git clone ${SRC_REPO}
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -f docker/Dockerfile -t ${CI_REGISTRY_IMAGE}/${IMAGE}:$CI_COMMIT_TAG --label $CI_COMMIT_TAG .
    - docker push ${CI_REGISTRY_IMAGE}/${IMAGE}:$CI_COMMIT_TAG
deploy_repo:
  stage: deploy
  image: docker:stable
  variables:
    DOCKER_HOST: "ssh://${SERVER_NAME}"
  only:
    - tags
  script:
    - apk update
    - apk upgrade
    - apk add python3 python3-dev py-pip build-base libffi-dev libressl-dev libgcc docker-compose git
    - apk add --update openssh-client
    - ssh -t ${SERVER_NAME} "mkdir -p /var/log/pyecho"
    - ssh -t ${SERVER_NAME} "mkdir -p $CI_PROJECT_DIR/docker/etc"
    - scp etc/acme.json ${SERVER_NAME}:$CI_PROJECT_DIR/docker/etc/acme.json 
    - scp etc/traefik.toml ${SERVER_NAME}:$CI_PROJECT_DIR/docker/etc/traefik.toml 
    - ssh -t ${SERVER_NAME} "chmod 600 $CI_PROJECT_DIR/docker/etc/acme.json"
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker-compose -f docker/docker-compose.yml down
    - docker-compose -f docker/docker-compose.yml up -d
 
testing:
  stage: test
  image: ruby:2.6
  only:
    - tags
  script:
    - cd ./etc/deploy-health-check
    - gem install bundler
    - bundle install
    - bundle exec rspec

